function dt = difftime(u, a, b)

    N = length(u)/2;
    u = reshape(u, 2, N);

    du = diff([a, u, b], 1, 2);
    norm_du_sq = sum(du.^2, 1);
    norm_du_sq_mx = [zeros(1,N+1); norm_du_sq];

    mu = ([a(2), u(2,:)] + [u(2,:), b(2)]);
    mu_mx = [mu; mu];

    R = sqrt(-norm_du_sq./mu*2);
    R_mx = [R; R];

    dt = -(-2*mu_mx(:,2:end).*du(:,2:end)...
           -norm_du_sq_mx(:,2:end))...
         ./mu_mx(:,2:end).^2./R_mx(:,2:end);
    dt = dt - (2*mu_mx(:,1:end-1).*du(:,1:end-1)...
           -norm_du_sq_mx(:,1:end-1))...
         ./mu_mx(:,1:end-1).^2./R_mx(:,1:end-1);
    dt = reshape(dt, 2*N, 1);

end
